<script setup lang="ts">
import { ref, computed, watchEffect, watch  } from "vue";
import { useQuasar } from "quasar";
import { useCounterMixin } from "@/stores/mixin";
import type { ResponseData } from "@/modules/05_placement/interface/response/Transfer";
import type { OpType } from "@/modules/05_placement/interface/response/Main";
import type { DataListRow } from "@/modules/11_discipline/interface/request/result";
import { useRoute } from "vue-router";
import DialogHeader from "@/components/DialogHeader.vue";
import http from "@/plugins/http";
import config from "@/app.config";
const route = useRoute();

const optionsType = ref<[]>([]);
const idPath = ref<string>(route.params.id as string);
const type = ref<string>("");
const rows = ref<DataListRow[]>([]);
const $q = useQuasar();
const selected = ref<ResponseData[]>([]);
const mixin = useCounterMixin();
const {
  showLoader,
  success,
  messageError,
  dialogConfirm,
  hideLoader,
  dialogMessageNotify,
} = mixin;

const props = defineProps({
  data: {
    type: Object,
    require: true,
    default: [],
  },
  columns: {
    type: Array,
    default: [],
  },
  visibleColumns: {
    type: Array,
    default: [],
  },
  Modal: Boolean,
  closeModal: Function,
  getData: Function,
  rows2: Array,
  filterKeyword2: String,
  title: String,
});

const checkSelected = computed(() => {
  if (selected.value.length === 0) {
    return true;
  }
});

//popup ยืนยันส่งัว
function saveOrder(){
  if (type.value) {
    dialogConfirm(
      $q,
      () => Ordersave(),
      `ยืนยัน${props.title}`,
      `ต้องการยืนยัน${props.title}ใช่หรือไม่?`
    );
  } else {
    dialogMessageNotify($q, "กรุณาเลือกประเภทคำสั่ง");
  }
};
//ส่งไปออกคำสั่ง
async function Ordersave() {
  const persons = selected.value.map((r) => r.id);

  // if (props.title == "ส่งไปออกคำสั่งลงโทษทางวินัย") {
  const body = {
    persons,
  };
  showLoader();
  await http
    .put(config.API.reportresult(idPath.value, type.value as string), body)
    .then((res: any) => {
      success($q, `${props.title}สำเร็จ`);
      props.closeModal?.();
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(async () => {
      props.getData?.();
      hideLoader();
    });
  // } else if (props.title == "ส่งไปออกคำสั่งงดโทษ/เพิ่มโทษ") {
  //   const body = {
  //     persons,
  //   };
  //   showLoader();
  //   await http
  //     .put(config.API.discardResult(idPath.value, type.value as string), body)
  //     .then((res: any) => {
  //       success($q, `${props.title}สำเร็จ`);
  //       props.closeModal?.();
  //     })
  //     .catch((e) => {
  //       messageError($q, e);
  //     })
  //     .finally(async () => {
  //       props.getData?.();
  //       hideLoader();
  //     });
  // }
}

const emit = defineEmits([
  "update:filterKeyword2",
  "update:selected",
  "update:type",
]);

const updateInput = (value: any) => {
  emit("update:filterKeyword2", value);
};

//รีเซ็ตค่าในช่องค้นหา
function Reset() {
  emit("update:filterKeyword2", "");
}

//----(ดึงข้อมูลประเภทคำสั่ง)------//
async function fecthTypeOption() {
  showLoader();
  await http
    .get(config.API.typeOrder())
    .then((res) => {
      // if (props.title == "ส่งไปออกคำสั่ง") {
      optionsType.value = res.data.result.filter(
        (e: OpType) =>
          e.commandCode === "C-PM-19" ||
          e.commandCode === "C-PM-20" ||
          e.commandCode === "C-PM-27" ||
          e.commandCode === "C-PM-28" ||
          e.commandCode === "C-PM-29" ||
          e.commandCode === "C-PM-30" ||
          e.commandCode === "C-PM-31"
      );
      // }
      // else {
      //   optionsType.value = res.data.result.filter(
      //     (e: OpType) =>
      //       e.commandCode === "C-PM-30" || e.commandCode === "C-PM-31"
      //   );
      // }
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

watchEffect(() => {
  if (props.Modal === true) {
    selected.value = [];
    type.value = "";
    rows.value = props.data.persons.filter(
      (item: any) => item.status === "NEW"
    );
    // if (props.title == "ส่งไปออกคำสั่งลงโทษทางวินัย") {
    //   rows.value = props.data.persons.filter(
    //     (item: any) => item.status !== "REPORT"
    //   );
    // } else if (props.title == "ส่งไปออกคำสั่งงดโทษ/เพิ่มโทษ") {
    //   rows.value = props.data.persons.filter(
    //     (item: any) => item.status == "REPORT" && item.statusDiscard == "NEW"
    //   );
    // }
  }
});

watch(
  () => props.title,
  () => {
    fecthTypeOption();
  }
);
</script>

<template>
  <q-dialog v-model="props.Modal" persistent>
    <q-card style="width: 1200px; max-width: 80vw">
      <DialogHeader :tittle="props.title" :close="closeModal" />
      <q-separator />
      <q-card-section class="q-pt-none">
        <div class="row justify-between">
          <div class="col-5">
            <q-toolbar style="padding: 0">
              <q-select
                outlined
                dense
                v-model="type"
                :options="optionsType"
                label="ประเภทคำสั่ง"
                style="width: 400px; max-width: auto"
                emit-value
                map-options
                option-label="name"
                option-value="id"
                use-input
                ><template v-slot:no-option>
                  <q-item>
                    <q-item-section class="text-grey">
                      ไม่มีข้อมูล
                    </q-item-section>
                  </q-item>
                </template>
              </q-select>
            </q-toolbar>
          </div>

          <div class="col-5">
            <q-toolbar style="padding: 0">
              <q-input
                borderless
                outlined
                dense
                debounce="300"
                :model-value="filterKeyword2"
                @update:model-value="updateInput"
                placeholder="ค้นหา"
                style="width: 850px; max-width: auto"
              >
                <template v-slot:append>
                  <q-icon v-if="filterKeyword2 == ''" name="search" />
                  <q-icon
                    v-if="filterKeyword2 !== ''"
                    name="clear"
                    class="cursor-pointer"
                    @click="Reset"
                  />
                </template>
              </q-input>
              <q-select
                v-model="props.visibleColumns"
                multiple
                outlined
                dense
                options-dense
                :display-value="$q.lang.table.columns"
                emit-value
                map-options
                :options="props.columns"
                option-value="name"
                options-cover
                style="min-width: 150px"
                class="gt-xs q-ml-sm"
              />
            </q-toolbar>
          </div>
        </div>

        <d-table
          :columns="props.columns"
          :rows="rows"
          :filter="filterKeyword2"
          row-key="id"
          :visible-columns="props.visibleColumns"
          selection="multiple"
          v-model:selected="selected"
        >
          <template v-slot:header-selection="scope">
            <q-checkbox
              keep-color
              color="primary"
              dense
              v-model="scope.selected"
            />
          </template>
          <template v-slot:body="props">
            <q-tr :props="props" class="cursor-pointer">
              <q-td>
                <q-checkbox
                  keep-color
                  color="primary"
                  dense
                  v-model="props.selected"
                />
              </q-td>
              <q-td v-for="col in props.cols" :key="col.name" :props="props">
                <div v-if="col.name == 'no'">
                  {{ props.rowIndex + 1 }}
                </div>
                <div
                  v-else-if="col.name === 'organization'"
                  class="table_ellipsis"
                >
                  {{ props.row.organization }}
                </div>
                <div v-else-if="col.name === 'salary'">
                  {{ props.row.salary.toLocaleString() }}
                </div>
                <div v-else>
                  {{ col.value }}
                </div>
              </q-td>
            </q-tr>
          </template>
        </d-table>
      </q-card-section>

      <q-card-actions align="right" class="bg-white text-teal">
        <q-btn
          :label="props.title"
          @click="saveOrder"
          :disable="checkSelected"
          color="public"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>
